﻿' Copyright (C) Brandan Tyler Lasley 2014
' Last Modified 01:18 8-9-2014
Imports System.IO

Public Class PTC
    Private m As New map(New Size(128, 128))
    Private Map_loaded As Boolean = False
    Private Sub OpenToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles OpenToolStripMenuItem.Click
        Dim openfiledialog As New OpenFileDialog()

        openfiledialog.InitialDirectory = Populous.Populous.Info.InstallPath & "\levels\"
        openfiledialog.Filter = "Populous Levels (levl*.dat)|levl*.dat|CSV (levl*.csv)|levl*.csv|Bitmap (levl*.bmp)|levl*.bmp|All files (*.*)|*.*"
        openfiledialog.FilterIndex = 0
        openfiledialog.RestoreDirectory = True

        If openfiledialog.ShowDialog() = System.Windows.Forms.DialogResult.OK Then
            Try
                If Path.GetExtension(openfiledialog.FileName).ToLower.Contains(".dat") Then
                    m.Load(openfiledialog.FileName, map.MapType.DAT)
                    Map_loaded = True
                    Render()
                    RenderBox.SizeMode = PictureBoxSizeMode.StretchImage
                ElseIf Path.GetExtension(openfiledialog.FileName).ToLower.Contains(".bmp") Then
                    m.Load(openfiledialog.FileName, map.MapType.BITMAP)
                    Map_loaded = True
                    Render()
                    RenderBox.SizeMode = PictureBoxSizeMode.StretchImage
                ElseIf Path.GetExtension(openfiledialog.FileName).ToLower.Contains(".csv") Then
                    m.Load(openfiledialog.FileName, map.MapType.CSV)
                    Map_loaded = True
                    Render()
                    RenderBox.SizeMode = PictureBoxSizeMode.StretchImage
                Else
                    MsgBox("Not Allow/Not Implemented")
                End If
            Catch Ex As Exception
                MessageBox.Show("Cannot read file from disk. Original error: " & Ex.Message)
            End Try
        End If
    End Sub

    Private Sub SaveToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles SaveToolStripMenuItem.Click
        Dim savefiledialog As New SaveFileDialog()

        savefiledialog.InitialDirectory = Populous.Populous.Info.InstallPath & "\levels\"
        savefiledialog.Filter = "Populous Levels (levl*.dat)|levl*.dat|CSV (levl*.csv)|levl*.csv|Bitmap (levl*.bmp)|levl*.bmp|All files (*.*)|*.*"
        savefiledialog.FilterIndex = 0
        savefiledialog.OverwritePrompt = False
        savefiledialog.RestoreDirectory = True

        If savefiledialog.ShowDialog() = System.Windows.Forms.DialogResult.OK Then
            Try

                If Path.GetExtension(savefiledialog.FileName).ToLower.Contains(".dat") Then
                    m.Save(savefiledialog.FileName, map.MapType.DAT)
                ElseIf Path.GetExtension(savefiledialog.FileName).ToLower.Contains(".bmp") Then
                    m.Save(savefiledialog.FileName, map.MapType.BITMAP)
                ElseIf Path.GetExtension(savefiledialog.FileName).ToLower.Contains(".csv") Then
                    m.Save(savefiledialog.FileName, map.MapType.CSV)
                Else
                    MsgBox("Not Allow/Not Implemented")
                End If

            Catch Ex As Exception
                MessageBox.Show("Cannot save file to the disk. Original error: " & Ex.Message)
            End Try
        End If
    End Sub

    Private Sub Img2Dat_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        ToolStripComboBox1.Items.Add("Stadic Water")
        ToolStripComboBox1.SelectedIndex = 0
        For Each Image In Directory.GetFiles("textures\water")
            If Path.GetExtension(Image) = ".bmp" Then
                ToolStripComboBox1.Items.Add(Path.GetFileNameWithoutExtension(Image))
            End If
        Next

        RenderBox.Image = m.StadicWater()
        RenderBox.SizeMode = PictureBoxSizeMode.StretchImage
    End Sub

    Private Sub ExitToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles ExitToolStripMenuItem.Click
        Application.Exit()
    End Sub

    Private Sub AboutToolStripMenuItem1_Click(sender As Object, e As EventArgs) Handles AboutToolStripMenuItem1.Click
        MsgBox("Copyright (C) Brandan Lasley 2014" & vbNewLine & "http://brandanlasley.com")
    End Sub

    Private Sub ToolStripComboBox1_SelectedIndexChanged(sender As Object, e As EventArgs) Handles ToolStripComboBox1.SelectedIndexChanged
        Render()
    End Sub


    Public Sub Render()
        If ToolStripComboBox1.SelectedItem = "Stadic Water" Or ToolStripComboBox1.SelectedItem = Nothing Then
            If Map_loaded = True Then
                RenderBox.Image = m.GenerateColorMap
            Else
                RenderBox.Image = m.StadicWater
            End If
        Else
            If Map_loaded = True Then
                RenderBox.Image = m.GenerateColorMap(New Bitmap("textures\water\" & ToolStripComboBox1.SelectedItem.ToString & ".bmp"))
            Else
                RenderBox.Image = m.StadicWater(New Bitmap("textures\water\" & ToolStripComboBox1.SelectedItem.ToString & ".bmp"))
            End If
        End If
    End Sub

    Private Sub Level2Bitmap(sender As Object, e As EventArgs) Handles LevelsBitmapsToolStripMenuItem.Click
        Try
            Dim LevelFolder = Nothing
            Dim ExportFolder = Nothing
            For i As Integer = 0 To 1
                If i = 0 Then
                    MsgBox("Please Select a Populous Level Folder.")
                Else
                    MsgBox("Please Select a Export Folder.")
                End If
                Dim folderDlg As New FolderBrowserDialog
                folderDlg.ShowNewFolderButton = True
                If (folderDlg.ShowDialog() = DialogResult.OK) Then
                    If i = 0 Then
                        LevelFolder = folderDlg.SelectedPath
                    Else
                        ExportFolder = folderDlg.SelectedPath
                    End If
                    Dim root As Environment.SpecialFolder = folderDlg.RootFolder
                Else
                    Return
                End If
            Next

            For Each popimg In Directory.GetFiles(LevelFolder)
                If Path.GetExtension(popimg).ToLower = ".dat" Then
                    If m.Load(popimg, map.MapType.DAT, True) = True Then
                        If ToolStripComboBox1.SelectedItem = "Stadic Water" Or ToolStripComboBox1.SelectedItem = Nothing Then
                            If Map_loaded = True Then
                                m.GenerateColorMap(Nothing, True).Save(ExportFolder & "\" & Path.GetFileNameWithoutExtension(popimg) & ".bmp")
                            Else
                                m.StadicWater(Nothing, True).Save(ExportFolder & "\" & Path.GetFileNameWithoutExtension(popimg) & ".bmp")
                            End If
                        Else
                            If Map_loaded = True Then
                                m.GenerateColorMap(New Bitmap("textures\water\" & ToolStripComboBox1.SelectedItem.ToString & ".bmp", True)).Save(ExportFolder & "\" & Path.GetFileNameWithoutExtension(popimg) & ".bmp")
                            Else
                                m.StadicWater(New Bitmap("textures\water\" & ToolStripComboBox1.SelectedItem.ToString & ".bmp", True)).Save(ExportFolder & "\" & Path.GetFileNameWithoutExtension(popimg) & ".bmp")
                            End If
                        End If
                    End If
                End If
            Next
            Render()
            MsgBox("Process Completed Succesfully!")
        Catch ex As Exception
            MsgBox("Error processing file: " & ex.Message & vbNewLine & ex.StackTrace)
        End Try
    End Sub

    Private Sub Bitmaps2Level(sender As Object, e As EventArgs) Handles BitmapsLevelsToolStripMenuItem.Click
        Try
            Dim LevelFolder = Nothing
            Dim ExportFolder = Nothing
            For i As Integer = 0 To 1
                If i = 0 Then
                    MsgBox("Please Select a Populous bitmap Folder.")
                Else
                    MsgBox("Please Select a Export Folder.")
                End If
                Dim folderDlg As New FolderBrowserDialog
                folderDlg.ShowNewFolderButton = True
                If (folderDlg.ShowDialog() = DialogResult.OK) Then
                    If i = 0 Then
                        LevelFolder = folderDlg.SelectedPath
                    Else
                        ExportFolder = folderDlg.SelectedPath
                    End If
                    Dim root As Environment.SpecialFolder = folderDlg.RootFolder
                Else
                    Return
                End If
            Next

            For Each popimg In Directory.GetFiles(LevelFolder)
                If Path.GetExtension(popimg).ToLower = ".bmp" Then
                    If m.Load(popimg, map.MapType.BITMAP, True) = True Then
                        m.Save(ExportFolder & "\" & Path.GetFileNameWithoutExtension(popimg) & ".dat", map.MapType.DAT, True)
                    End If
                End If
            Next
            Render()
            MsgBox("Process Completed Succesfully!")
        Catch ex As Exception
            MsgBox("Error processing file: " & ex.Message & vbNewLine & ex.StackTrace)
        End Try
    End Sub

    Private Sub DeleteAllObjectsOnMapToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles DeleteAllObjectsOnMapToolStripMenuItem.Click
        Dim openfiledialog As New OpenFileDialog()

        openfiledialog.InitialDirectory = Populous.Populous.Info.InstallPath & "\levels\"
        openfiledialog.Filter = "Populous Levels (levl*.dat)|levl*.dat|All files (*.*)|*.*"
        openfiledialog.FilterIndex = 0
        openfiledialog.RestoreDirectory = True

        If openfiledialog.ShowDialog() = System.Windows.Forms.DialogResult.OK Then
            Try
                If Path.GetExtension(openfiledialog.FileName).ToLower.Contains(".dat") Then
                    If MsgBox("Are you sure yo want to delete ALL objects on this map?", vbYesNo) = vbYes Then
                        m.Load(openfiledialog.FileName, map.MapType.DAT)
                        m.Save(openfiledialog.FileName, map.MapType.DAT, False, True)
                        Map_loaded = True
                        Render()
                        RenderBox.SizeMode = PictureBoxSizeMode.StretchImage
                        MsgBox("Map Loaded & Objects Deleted!")
                    Else
                        MsgBox("Map not loaded, deletion did not occur")
                    End If
                Else
                    MsgBox("Not Allow/Not Implemented")
                End If
            Catch Ex As Exception
                MessageBox.Show("Cannot read file from disk. Original error: " & Ex.Message)
            End Try
        End If
    End Sub
End Class

Public Class map
    Structure Points
        Public ID As Integer
        Public X As Integer
        Public Y As Integer
        Public Z As Short
    End Structure

    Structure Objects ' Every Struct after Points was never finished, not useful in this project.
        Public ID As Integer
        Public X As Integer
        Public Y As Integer
        Public Z As Short
    End Structure

    Structure NoAccessBlocks
        Public ID As Integer
        Public X As Integer
        Public Y As Integer
        Public disabled As Integer
    End Structure

    Structure SunLightBlocks
        Public ID As Integer
        Public X As Integer
        Public Y As Integer
    End Structure

    Structure SavePlayerInfo
        Public ID As Integer
        Public X As Integer
        Public Y As Integer
        Public tribe As Populous.Populous.tribe
    End Structure

    Shared MapSize As Size

    Public Classic_Water = 0

    Public Sub New(s As Size)
        MapSize = New Size(s)
        ReDim heights(MapSize.Height * MapSize.Width)
        ReDim NoAccess(MapSize.Height * MapSize.Width)
        ReDim SunLight(MapSize.Height * MapSize.Width)
    End Sub

    Public heights() As Points                    '
    Public NoAccess() As NoAccessBlocks           ' 
    Public SunLight() As SunLightBlocks           ' 
    Public SavePlayer(64) As SavePlayerInfo       '
    Public Obj(1999) As Objects                   ' Populous TB Limits of Objecs is 2000

    Public Enum MapType
        DAT
        CSV
        BITMAP
    End Enum

    Public Function StadicWater(Optional img As Bitmap = Nothing, Optional ignore_errors As Boolean = False) As Bitmap
        Try
            If IsNothing(img) Then
                Dim bitmap As New Bitmap(MapSize.Width, MapSize.Height)
                Dim r As New FastRandom.FastRandom

                For X As Integer = 0 To MapSize.Width - 1
                    For Y As Integer = 0 To MapSize.Height - 1
                        bitmap.SetPixel(X, Y, Color.FromArgb(0, 0, r.Next(100, 255)))
                    Next
                Next
                Return bitmap
            Else
                Return New Bitmap(img)
            End If
        Catch ex As Exception
            If ignore_errors = False Then
                MsgBox("Error processing file: " & ex.Message & vbNewLine & ex.StackTrace)
            End If
        End Try
        Return Nothing
    End Function
    Public Function GenerateColorMap(Optional img As Bitmap = Nothing, Optional ignore_errors As Boolean = False) As Bitmap
        Try
            Dim bitmap As New Bitmap(MapSize.Width, MapSize.Width)
            Dim r As New FastRandom.FastRandom

            If IsNothing(img) Then
                For X As Integer = 0 To MapSize.Width - 1
                    For Y As Integer = 0 To MapSize.Height - 1
                        bitmap.SetPixel(X, Y, Color.FromArgb(0, 0, r.Next(100, 255)))
                    Next
                Next
            Else
                bitmap = New Bitmap(img)
            End If

            For Each Point In heights
                If Point.Z > 0 Then
                    If (Point.Z \ 4) > 255 Then
                        bitmap.SetPixel(Point.X, Point.Y, Color.FromArgb(0, 1, 0))
                    Else
                        bitmap.SetPixel(Point.X, Point.Y, Color.FromArgb(0, 255 - (Point.Z \ 4), 0))
                    End If
                End If
            Next

            Return bitmap
        Catch ex As Exception
            If ignore_errors = False Then
                MsgBox("Error processing file: " & ex.Message & vbNewLine & ex.StackTrace)
            End If
        End Try
        Return Nothing
    End Function

    Public Sub LoadBitMap2Level(ByVal bitmap As Bitmap, Optional ignore_errors As Boolean = False)
        Try
            Dim Point = 0
            For X As Integer = 0 To MapSize.Width - 1
                For Y As Integer = 0 To MapSize.Height - 1
                    heights(Point).X = X
                    heights(Point).Y = Y

                    If bitmap.GetPixel(X, Y).B > 0 Then
                        heights(Point).Z = 0
                    ElseIf bitmap.GetPixel(X, Y).G > 0 Then

                        If bitmap.GetPixel(X, Y).G = 1 Then
                            heights(Point).Z = 255 * 4
                        Else
                            heights(Point).Z = (255 - bitmap.GetPixel(X, Y).G) * 4
                        End If

                    Else
                        heights(Point).Z = 0
                    End If
                    Point = Point + 1
                Next
            Next
        Catch ex As Exception
            If ignore_errors = False Then
                MsgBox("Error processing file: " & ex.Message & vbNewLine & ex.StackTrace)
            End If
        End Try
    End Sub

    Function Load(ByVal filepath As String, ByVal filetypep As MapType, Optional ignore_errors As Boolean = False)
        Try
            If filetypep = MapType.DAT Then
                Dim reader As New BinaryReader(File.Open(filepath, FileMode.Open))

                Dim Point = 0
                For x As Integer = 0 To MapSize.Height - 1
                    For y As Integer = 0 To MapSize.Width - 1

                        ' Load height UShort is unsigned Word, and Short is signed word
                        Dim Height As Short = reader.ReadUInt16()


                        If Point > 0 Then
                            heights(Point).ID = Point + 1
                        End If
                        heights(Point).X = x
                        heights(Point).Y = y
                        heights(Point).Z = Height

                        Point = Point + 1
                    Next
                Next

                reader.Close()
            ElseIf filetypep = MapType.CSV Then
                Dim input = My.Computer.FileSystem.ReadAllText(filepath).Split(vbNewLine)

                For i As Integer = 0 To (128 * 128)
                    Dim currline = input(i).Replace(vbLf, Nothing)
                    If Not currline = "X,Y,Z" Then
                        heights(i).X = (currline.Split(",")(0))
                        heights(i).Y = (currline.Split(",")(1))
                        heights(i).Z = (currline.Split(",")(2))
                    End If
                Next

            ElseIf filetypep = MapType.BITMAP Then
                Dim map As New Bitmap(filepath)
                LoadBitMap2Level(map)
            End If
            Return True
        Catch ex As Exception
            If ignore_errors = False Then
                MsgBox("Error loading file: " & ex.Message & vbNewLine & ex.StackTrace)
            End If
            Return False
        End Try
    End Function

    Function Save(ByVal filepath As String, ByVal filetypep As MapType, Optional ignore_errors As Boolean = False, Optional deleteobjects As Boolean = False)
        Try
            If filetypep = MapType.DAT Then

                Dim exists As Boolean = True
                If Not My.Computer.FileSystem.FileExists(filepath) Then
                    exists = False
                    File.Create(filepath).Dispose()
                End If

                Dim writer As New BinaryWriter(File.Open(filepath, FileMode.Open))

                For x As Integer = 0 To MapSize.Width - 1
                    For y As Integer = 0 To MapSize.Height - 1
                        For Point = 0 To heights.Length
                            If (heights(Point).X = x And heights(Point).Y = y) Then
                                writer.Write(heights(Point).Z)
                                Exit For
                            End If
                        Next
                    Next
                Next

                If Not exists Or deleteobjects = True Then
                    ' Unused Data, 0 byte it
                    Do Until (writer.BaseStream.Position > &HFFFF)
                        writer.Write(CByte(0))
                    Loop

                    ' No Access Blocks 1 = No Access 0 = Free Roam
                    Do Until (writer.BaseStream.Position >= &H13FFF)
                        writer.Write(CByte(0))
                    Loop

                    ' Save Player Info
                    Do Until (writer.BaseStream.Position >= &H1403F)
                        writer.Write(CByte(0))
                    Loop

                    ' Sunlight Info
                    Do Until (writer.BaseStream.Position >= &H14042)
                        writer.Write(CByte(0))
                    Loop

                    ' Objects
                    Do Until (writer.BaseStream.Position >= &H2EDF2)
                        writer.Write(CByte(0))
                    Loop

                    ' End Padding 
                    Do Until (writer.BaseStream.Position >= &H2EE88)
                        writer.Write(CByte(0))
                    Loop
                    writer.Write(CByte(0))
                End If

                writer.Close()
            ElseIf filetypep = MapType.CSV Then
                Dim output = Nothing
                output += "X,Y,Z" & vbNewLine
                For Each Point In heights
                    output += Point.X & "," & Point.Y & "," & Point.Z & vbNewLine
                Next
                My.Computer.FileSystem.WriteAllText(filepath, output, False)
            ElseIf filetypep = MapType.BITMAP Then
                GenerateColorMap.Save(filepath)
            End If
            Return True
        Catch ex As Exception
            If ignore_errors = False Then
                MsgBox("Error saving file: " & ex.Message & vbNewLine & ex.StackTrace)
            End If
            Return False
        End Try
    End Function
End Class